# squish.pm  --  common routines
#
# Copyright (c) 2001-2002 Andrew McGill and Leading Edge Business Solutions
# (South Africa).  This software may be redistributed and/or modified only
# under the terms of the GNU General Public Licence, version 2, as published by
# the Free Software Foundation, and contained in the file COPYING. 
# 
# All other rights are reserved, and no warranty is implied.  Despite any
# appearance to the contrary, this software is not fit for ANY purpose you may
# conceive, and should not be used on your system under any circumstances.
# 
# This program reads a squid log from stdin and creates a time and data based
# blocklist for use with squid

$pmrevision = '$Id: squish.pm,v 1.5 2005/11/21 13:23:08 andrewm Exp $';

use Storable qw( lock_store lock_retrieve );

$statedir = "/var/lib/squish";

if (! -d $statedir) {
	mkdir $statedir,0775;
}
if (! -r $statedir) {
	$statedir=".";
}
$statefilename = "$statedir/userdb.stor";

sub getcurrentstate()
{
	if ( ! -e $statefilename ) {
		$empty{"version"}="All your swish are squish";
		lock_store(\%empty,$statefilename);
	}
	$state=lock_retrieve($statefilename);
	$userdb=$$state{"userdb"};
}
sub putcurrentstate()
{
	$$state{"userdb"}=$userdb;
	lock_store $state, $statefilename;
}

